﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using TwinCAT.Ads;

namespace WindowsFormsApplication1
{
    [StructLayout(LayoutKind.Sequential, Pack = 8)]
    struct TestStruct
    {
        [MarshalAs(UnmanagedType.I2)]
        public Int16 nData;
        [MarshalAs(UnmanagedType.I1)]
        public byte byVal;
        [MarshalAs(UnmanagedType.R4)]
        public float fVal;

    }
    public partial class Form1 : Form
    {
        public TcAdsClient _client = null;
        public int _handBOOl = 0;
        public int _handByte = 0;
        public int _handInt = 0;
        public int _handArray = 0;
        public int _handStruct = 0;

        public int _notificationHandleInt = 0;
        public int _notificationHandleStruct = 0;
        public int _handStruct2 = 0;

        public Form1()
        {
            InitializeComponent();
        }


        private void button1_Click(object sender, EventArgs e)
        {
            AdsStream stream = new AdsStream(100);
            AdsBinaryReader reader = new AdsBinaryReader(stream);
            _client.Read(_handBOOl, stream);
            textBox1.Text = reader.ReadBoolean().ToString();
            stream.Seek(0, System.IO.SeekOrigin.Begin);
            _client.Read(_handByte, stream);
            textBox2.Text = reader.ReadByte().ToString();
            stream.Seek(0, System.IO.SeekOrigin.Begin);
            _client.Read(_handStruct, stream);
            textBox8.Text = reader.ReadInt16().ToString();  
            textBox9.Text = reader.ReadByte().ToString();
            reader.ReadByte();
            textBox10.Text = reader.ReadSingle().ToString();
            stream.Seek(0, System.IO.SeekOrigin.Begin);
            textBox3.Text = reader.ReadInt16().ToString();
            _client.Read(_handArray, stream);
            stream.Seek(0, System.IO.SeekOrigin.Begin);
            textBox4.Text = reader.ReadInt16().ToString();
            textBox5.Text = reader.ReadInt16().ToString();
            textBox6.Text = reader.ReadInt16().ToString();
            textBox7.Text = reader.ReadInt16().ToString();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            try
            {
                _client = new TcAdsClient();
                _client.AdsNotification += new AdsNotificationEventHandler(AdsNotificationEventOnChange);

                _client.Connect(851);
                _handBOOl = _client.CreateVariableHandle("MAIN.Data_Bool");
                _handByte = _client.CreateVariableHandle("MAIN.Data_Byte");
                _handInt = _client.CreateVariableHandle("MAIN.Data_Int");
                _handArray = _client.CreateVariableHandle("MAIN.Data_Array");
                _handStruct = _client.CreateVariableHandle("MAIN.Data_Struct");
                _handStruct2 = _client.CreateVariableHandle("GVL.stAxis");

            }
            catch (Exception ex) { }


        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            _client.DeleteVariableHandle(_handBOOl);
            _client.DeleteVariableHandle(_handByte);
            _client.DeleteVariableHandle(_handInt);
            _client.DeleteVariableHandle(_handArray);
            _client.DeleteVariableHandle(_handStruct);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            AdsStream stream = new AdsStream(100);
            AdsBinaryWriter writer = new AdsBinaryWriter(stream);
            //writer.Write(Boolean.Parse(textBox11.Text));
            //_client.Write(_handBOOl, stream,0,1);
            //stream.Seek(0, System.IO.SeekOrigin.Begin);
            //writer.Write(Byte.Parse(textBox12.Text));
            //_client.Write(_handByte, stream,0,1);
            stream.Seek(0, System.IO.SeekOrigin.Begin);
            writer.Write(Int16.Parse(textBox18.Text));
            writer.Write(Byte.Parse(textBox19.Text));
            writer.Write((Byte)0);
            writer.Write(float.Parse(textBox20.Text));
            _client.Write(_handStruct, stream,0,8);

        }

        private void button6_Click(object sender, EventArgs e)
        {
            try
            {
                textBox1.Text = _client.ReadAny(_handBOOl, typeof(Boolean)).ToString();
                textBox2.Text = _client.ReadAny(_handByte, typeof(Byte)).ToString();
                short[] testint = (short[])_client.ReadAny(_handArray, typeof(short[]), new int[] { 4 });
                TestStruct tstruct = (TestStruct)_client.ReadAny(_handStruct, typeof(TestStruct));
                textBox8.Text = tstruct.nData.ToString();
                textBox9.Text = tstruct.byVal.ToString();
                textBox10.Text = tstruct.fVal.ToString();
            }
            catch(Exception ex) { }

        }

        private void button4_Click(object sender, EventArgs e)
        {
            int readBytes = 0;
            AdsStream stream = new AdsStream(100);
            AdsBinaryReader reader = new AdsBinaryReader(stream);
            AdsErrorCode code = _client.TryRead((uint)AdsReservedIndexGroups.SymbolValueByHandle,(uint)0, stream,out readBytes);
            textBox1.Text = reader.ReadBoolean().ToString();
            stream.Seek(0, System.IO.SeekOrigin.Begin);
            _client.TryRead((uint)AdsReservedIndexGroups.SymbolValueByHandle, (uint)_handByte, stream,out readBytes);
            textBox2.Text = reader.ReadByte().ToString();
            stream.Seek(0, System.IO.SeekOrigin.Begin);
            _client.TryRead((uint)AdsReservedIndexGroups.SymbolValueByHandle, (uint)_handStruct, stream,out readBytes);
            textBox8.Text = reader.ReadInt16().ToString();
            textBox9.Text = reader.ReadByte().ToString();
            reader.ReadByte();
            textBox10.Text = reader.ReadSingle().ToString();
            stream.Seek(0, System.IO.SeekOrigin.Begin);
            _client.TryRead((uint)AdsReservedIndexGroups.SymbolValueByHandle, (uint)_handInt, stream,out readBytes);
            textBox3.Text = reader.ReadInt16().ToString();
            _client.TryRead((uint)AdsReservedIndexGroups.SymbolValueByHandle, (uint)_handArray, stream,out readBytes);
            stream.Seek(0, System.IO.SeekOrigin.Begin);
            textBox4.Text = reader.ReadInt16().ToString();
            textBox5.Text = reader.ReadInt16().ToString();
            textBox6.Text = reader.ReadInt16().ToString();
            textBox7.Text = reader.ReadInt16().ToString();
        }

        private void button8_Click(object sender, EventArgs e)
        {
            _notificationHandleInt = _client.AddDeviceNotificationEx("MAIN.Data_Int", AdsTransMode.OnChange, 1, 0, this, typeof(short));
            _notificationHandleStruct = _client.AddDeviceNotificationEx("MAIN.Data_Struct", AdsTransMode.OnChange, 1, 0, this, typeof(TestStruct));
        }

        public void AdsNotificationEventOnChange(object sender, AdsNotificationEventArgs e)
        {
            AdsBinaryReader reader = new AdsBinaryReader(e.DataStream);
            if(e.NotificationHandle == _notificationHandleInt)
                Debug.WriteLine(reader.ReadInt16());
            else if(e.NotificationHandle == _notificationHandleStruct)
            {
                Debug.WriteLine(reader.ReadInt16());
                Debug.WriteLine(reader.ReadByte());
                reader.ReadByte();
                Debug.WriteLine(reader.ReadSingle());
            }

        }

        private void button7_Click(object sender, EventArgs e)
        {
            TcAdsClient _ads = new TcAdsClient();
            _ads.Connect(12345);
            AdsStream stream = new AdsStream(100);
            _ads.Read(0, 0, stream);
        }

        private void button9_Click(object sender, EventArgs e)
        {
            Plc_StAxisInfo info = (Plc_StAxisInfo)_client.ReadAny(_handStruct2, typeof(Plc_StAxisInfo));
        }
    }
}
